execute block (fk_1 integer = :fk_bd_1, proc_discount decimal(3,2)= :percent)
as
declare variable fk_cena integer;
declare variable fk_11 integer;
declare variable nds type of column bd_tovar.nds;
declare variable fk_tovar integer;
declare variable cena_rash type of column bd_cpr_now.cena;
declare variable cena_w_nds type of column bd_11.cena_pr_with_nds;
declare variable cena_wo_nds type of column bd_11.cena_pr_without_nds;
declare variable summa1_w_nds type of column bd_1.sum_with_nds;
declare variable summa1_wo_nds type of column bd_1.sum_without_nds;
declare variable summa11_w_nds type of column bd_11.summa_with_nds;
declare variable summa11_wo_nds type of column bd_11.summa_without_nds;
declare variable cnt type of column bd_11.cnt;
begin
  proc_discount=coalesce(:proc_discount,0);

  select bd_firm.fk_bd_cena_basic
  from bd_1
  join bd_firm on bd_firm.field_key=bd_1.fk_bd_firm
  where bd_1.field_key=:fk_1
  into :fk_cena;

  for select bd_11.field_key, bd_tovar.nds, bd_11.fk_bd_tovar, bd_11.cnt
  from bd_11 join bd_tovar on bd_tovar.field_key=bd_11.fk_bd_tovar
  where bd_11.fk_bd_1=:fk_1
  into :fk_11, :nds, :fk_tovar, :cnt
  do
  begin
     cena_rash=null;
     select cena from bd_cpr_now c where c.fk_bd_tovar=:fk_tovar and c.fk_bd_cena=:fk_cena into :cena_rash;
     cena_rash=coalesce(:cena_rash,0);
     cena_w_nds=:cena_rash*(1-:proc_discount/100);
     cena_wo_nds=:cena_w_nds/(100+:nds)*100;
     summa11_w_nds=:cena_w_nds*:cnt;
     summa11_wo_nds=:summa11_w_nds/(100+:nds)*100;

     update bd_11 set cena_pr_with_nds=:cena_w_nds, cena_pr_without_nds=:cena_wo_nds,
                      summa_with_nds=:summa11_w_nds,summa_without_nds=:summa11_wo_nds,
                      summa_nds=:summa11_w_nds-:summa11_wo_nds
     where field_key=:fk_11;

  end

end
